import java.io.*;

final class Henkan{

static boolean result;	//ɐ
static boolean error;	//G[
static boolean intro;	//Cg邩
private static boolean renpu;	//OA̒
private static int[] melody;		//Fp
private static boolean slur;		//X[p
private static int[] q;		//qp
private static boolean[] update_q;	//qXVp

//1gbN̍őe
private static final int TR_MAX = 0x800;
//gbN̐
private static final int TRACK = 9;
//[v̍ő吔
private static final int LOOP_MAX = 128;

// (a)n܂
private static final int[] TONE = {9, 11, 0, 2, 4, 5, 7};
//y킲Ƃ̉̂(␳ɗp)
//private static final int[] TRNSMAP = {12, 0, 29, 12, 0, 0, 0, 0, 0, -5, 18, 0, -5, 0, 0, 8, 0, 0, 0};	// IN^[ul
private static final int[] TRNSMAP = {0, 0, 5, 0, 0, 0, 0, 0, 0, -5, 6, 0, -5, 0, 0, 8, 0, 0, 0};	// IN^[u

//ϊO\[X
private static byte[] res;
//ϊO\[X |C^
private static int ptr;
//ϊf[^ 8ch + [vp1ch
private static byte[][] epi;
//epi {
private static byte[] epiepi;
//epiepi ̃TCY
private static int epiepi_size;
//ϊf[^ |C^ 8ch
private static int[] ptrE;
//ϊf[^ |C^̃AhX
private static int[] ptrA;
//ϊf[^ |C^̃AhX(Cg)
private static int[] ptrI;
//ϊf[^ [vpAhX
private static int[] ptrL;

//f[^ރAhX
private static int startFILE;
private static int startARAM;


private static int tr;			//gbNԍ
private static int octave;		//IN^[u
private static int def_long;	//ftHg̉
private static int last_long;	//Ỏ
private static int last_tr;		//ÕgbN([vp)
private static int line;		//s

private static int start_loop;	//()[vg񂵗p

//
static final int[] MML = {
	'\0',

	'c','d','e','f','g','a','b',
	'r',
	'^',	//^C
	'&',	//X[

	'w',	//}X^[
	'v',	//`l
	't',
	'o',
	'p',	//ru[g
	'q',	//NI^CY?
	'y',	//Xs[J[ʒu
	'l',	//ftHg̉

	'[',']',	//[v
	'{','}',	//OA
	'<','>',	//IN^[u
	'#',	//gbNԍ
	'@',	//F
	'/',	//Cg̏I
	'*',	//[vg
//	';',
//	'.',
	'!',	//I
	'$',	//ړ
};

//	#	#	#	#	#	#	#	#	#	#
//	ʏ탁bZ[W
//	#	#	#	#	#	#	#	#	#	#
private static void p(String s){
	System.out.println(s);
}

private static void p(String s, boolean b){
	if(b || !b)System.out.print(s);
}

//	#	#	#	#	#	#	#	#	#	#
//	G[bZ[W
//	#	#	#	#	#	#	#	#	#	#
private static void err(int i, String s){
	if(i > 0)
		System.out.print(Integer.toString(i) + " s ");
	System.out.println("G[:" + s);
	result = false;
	error = true;
}


//	#	#	#	#	#	#	#	#	#	#
//	
//	#	#	#	#	#	#	#	#	#	#
static void init(){
	epi = new byte[TRACK][TR_MAX];
	epiepi = new byte[0x4000];
	epiepi_size = 64;
	ptrA = new int[TRACK];
	ptrI = new int[8];
	ptrE = new int[TRACK];
	ptrL = new int[LOOP_MAX + 1];

	q = new int[TRACK];
	update_q = new boolean[TRACK];
	melody = new int[TRACK];
}

//	#	#	#	#	#	#	#	#	#	#
//	Jn
//	file: smc
//	mode: 0:overworld 1:level
//	#	#	#	#	#	#	#	#	#	#
static void run(String file, int mode){

	result = true;
	error = false;
	init();

	//Jn
	//overworld
	if(mode == 0){
		startFILE = AddMusic.startFILE_o + 0x162D + 4;
		startARAM = AddMusic.startARAM_o;
		for(int i = 0x11; i <= 0x18; i++){
			//ϊ
			if(henkan(i)){
				//ۑ
				store_spc((i - 1) & 7);
			}
			if(error)return;
			//|
			System.gc();
		}
		//t@Cɏ
		save_spc(file, startFILE, 0x2BC0);//0x2BC8

	//level
	}else if(mode == 1){
		startFILE = AddMusic.startFILE_l;
		startARAM = AddMusic.startARAM_l;
		for(int i = 0x20; i <= 0x3F; i++){
			//ϊ
			if(henkan(i)){
				//ۑ
				store_spc(i & 3);
			}
			if(error)return;
			//t@Cݔ
			if((i & 3) == 3){
				//t@Cɏ
				if(ptr > 0){
					save_spc(file, startFILE, 0x1800);
					startFILE += 0x2000;
				}
				//ď
				epiepi_size = 64;
				//G[
				if(error)return;
				System.gc();
			}
		}
	}else{
		err(-1, "sȃG[");
	}

}

//	#	#	#	#	#	#	#	#	#	#
//	MMLt@CSPC`ɕϊ
//	num_src  : ǂݍމyf[^̃t@C̔ԍ
//	#	#	#	#	#	#	#	#	#	#
private static boolean henkan(int num_src){
	String src = Integer.toString(num_src, 16) + ".txt";
	//yf[^
	if((res = load_res(src)) == null){
		p(src + ":Ȃ");
		return false;
	}

	//
	intro = renpu = false;
	line = 1;
	octave = 4;
	tr = last_tr =
	def_long = 8;
	last_long = -1;
	slur = false;

	ptr =
	start_loop = 0;

	int i;
	for(i = TRACK - 1; i >= 0; i--){
		ptrE[i] = 0;
		q[i] = 0x7F;
		update_q[i] = true;
		melody[i] = -1;
	}
	for(i = LOOP_MAX; i >= 0; i--)	ptrL[i] = 0;
	for(i = 7; i >= 0; i--)	ptrI[i] = 0;

	//쐬
	make_music();
	//JnAhXZo
	make_add();
	//[vAhXZo
	make_loop();
	//I
	return true;
}

//	#	#	#	#	#	#	#	#	#	#
//	ϊSPCf[^obt@ɒ~
//	num: src_num & 7
//	#	#	#	#	#	#	#	#	#	#
private static void store_spc(int num){
	int i, j, size, total;
	total = 0;
	//e`l̃f[^{
	p("gbN", false);
	for(i = 0; i < TRACK; i++){
		size = ptrE[i] + 1;
		System.arraycopy(epi[i], 0, epiepi, epiepi_size, size);
		epiepi_size += size;
		total += size;
		p(i + "F" + Integer.toHexString(size) + "oCg ", false);
	}

	p(" v " + Integer.toHexString(total) + " (" + total + ")oCg");

	//e`l̃AhX(Cg)
	for(i = 0; i < 8; i++){
		j = ptrA[i];
		epiepi[epiepi_size++] = byte2(j);
		epiepi[epiepi_size++] = byte2(j >>> 8);
	}
	//e`l̃AhX(C)
	if(intro){
	for(i = 0; i < 8; i++){
		epiepi[epiepi_size++] = byte2(ptrI[i]);
		epiepi[epiepi_size++] = byte2(ptrI[i] >>> 8);
	}
	}//if intro
	//is\
	num *= 8;
	j = num;
	i = startARAM + epiepi_size - (intro ? 32 : 16);
	epiepi[num++] = byte2(i);
	epiepi[num++] = byte2(i >>> 8);
	i = startARAM + epiepi_size - 16;
	epiepi[num++] = byte2(i);
	epiepi[num++] = byte2(i >>> 8);
	epiepi[num++] = (byte)0xFF;
	epiepi[num++] = 0x00;
	i = startARAM + j + 2;
	epiepi[num++] = byte2(i);
	epiepi[num++] = byte2(i >>> 8);
}

//	#	#	#	#	#	#	#	#	#	#
//	ϊSPCf[^t@Cɏ
//	file : t@C
//	startFILE: ݐAhX
//	limit: e
//	#	#	#	#	#	#	#	#	#	#
private static void save_spc(String s,int startFILE, int limit){
	int datasize;
	RandomAccessFile o = null;
	File file = new File(s);

	//t@C݂邩
	if(!file.exists()){
		err(-1, s + " ܂B");
		return;
	}
	try {
		o = new RandomAccessFile(file, "rw");
		o.seek(startFILE);
		datasize = epiepi_size;
		if(datasize > limit){
			datasize = limit;
			err(-1, "f[^傫܂");
		}
		//f[^
		o.write(epiepi, 0, datasize);

	}catch(Exception e){
		err(-1, "t@Cݎs " + e.toString());
	}finally{
		try {
			if (null != o) o.close();
		}catch(Exception e) {
			err(-1, "t@CN[Ys");
		}
	}
}

//	#	#	#	#	#	#	#	#	#	#
//	\[Xǂݍ
//	#	#	#	#	#	#	#	#	#	#
private static byte[] load_res(String s){
	int datasize = 0;
	byte[] buf = new byte[0x4000];
	byte[] data;

	FileInputStream f = null;
	File file = new File(s);
	//t@C݂邩
	if(!file.exists()) return null;

	//J
	try{
		f = new FileInputStream(file);
		datasize = f.read(buf);
		//
		f.close();

	}catch(IOException e){
		err(-1, s + " ǂ݂ݎs");
		return null;
	}

	data = new byte[datasize + 1];
	datasize = data.length - 1;
	System.arraycopy(buf, 0, data, 0, datasize);
	data[datasize] = 0x00;
	p(s + " ̃TCY: " + datasize);
	return data;
}

//	#	#	#	#	#	#	#	#	#	#
//	int2byte
//	#	#	#	#	#	#	#	#	#	#
private static byte byte2(int i){
	return (byte)(i & 0xFF);
}

//	#	#	#	#	#	#	#	#	#	#
//	𐔒lɕϊ
//  b : G[o
//	#	#	#	#	#	#	#	#	#	#
private static int getInt(boolean b){
	int n = 0;	//
	int c = 0;	//
	int x;		//|C^̕
	while(true){
		x = res[ptr] - 0x30;	// '0'
		if(x >= 0 && x <= 9){
			n = n * 10 + x;
			c++;
		}else{
			break;
		}
		ptr++;
	}
	//s
	if(c == 0){
		if(b)
			err(line, "lwł(10i)");
		return -1;
	}
	return n;
}
//	#	#	#	#	#	#	#	#	#	#
//	16iɕϊ
//  b : G[o
//	#	#	#	#	#	#	#	#	#	#
private static int getHex(){
	int n = 0;	//
	int c = 0;	//
	int x;		//|C^̕
	while(true){
		x = res[ptr];
		if(x >= 0x30 && x <= 0x39){	// 0~9
			x -= 0x30;
		}else if(x >= 0x41 && x <= 0x5A){	// A~Z
			x -= 0x41 - 10;
		}else if(x >= 0x61 && x <= 0x7A){	// a~z
			x -= 0x61 - 10;
		}else{
			break;
		}
		if(x <= 16){
			n = n * 16 + x;
			c++;
		}
		ptr++;
	}
	//s
	if(c == 0){
		err(line, "lwł(16i)");
		return -1;
	}
	return n;
}

//	#	#	#	#	#	#	#	#	#	#
// ϊ
//	n :  char(cdefgab)  int`
//	#	#	#	#	#	#	#	#	#	#
private static int getTone(int n){
	int x = res[ptr];	//|C^̕

	//ϊ 0x61 = 'a'
	n = TONE[n - 0x61] + (octave - 1) * 12 + 0x80;

	// "+"
	if(x == 0x2B){
		n++;
		ptr++;
	// "-"
	}else if(x == 0x2D){
		n--;
		ptr++;
	}

	//FƂ̉␳
	x = melody[tr];
	if (x >= 0 && x <= 18)
		n -= TRNSMAP[x];

	//߂͈͂̒l
	if(n < 0x80){
		err(line, "Ⴗ܂");
		return -1;
	}else if(n > 0xC5){
		err(line, "܂");
		return -1;
	}
	return n;
}

//	#	#	#	#	#	#	#	#	#	#
// ϊ
//	Ԃl : sȒl̂Ƃ 0
//	#	#	#	#	#	#	#	#	#	#
private static int getLength(){
	int m = getInt(false);
	//lȂƂ ftHg̉
	if(m < 1) m = def_long;

	//މ
	m = 192 / m;

	//t_
	if(res[ptr] == 0x2E){ // '.'
		ptr++;
		if(res[ptr] == 0x2E){
			ptr++;
			m = m * 7 / 4;
		}else
			m = m * 3 / 2;
	}
	//OA
	if(renpu) m = m * 2 / 3;

	//ỎENI^CYƓƂ 0 Ԃ
	if(m == last_long && !update_q[tr]) return 0;

	return m;
}

//	#	#	#	#	#	#	#	#	#	#
//	ϊ
//	#	#	#	#	#	#	#	#	#	#
private static void input(int n){
	//eʃI[o[
	if(ptrE[tr] == TR_MAX) return;
	epi[tr][ptrE[tr]++] = (byte)(n & 0xFF);
}

//	#	#	#	#	#	#	#	#	#	#
//	f[^ϊ
//	#	#	#	#	#	#	#	#	#	#
private static void make_music(){
	char ope;	//
	int i;	//ėp
	int x;	//|C^̕
	int m, n;	//getLength, getInt p
	while(ptr < res.length){
		//Xy[X, ^u΂
		switch((x = res[ptr])){
		//s
		case 0x0A:
			ptr++;
			line++;
			continue;
		//Xy[X, ^u
		case 0x09:
		case 0x0D:
		case 0x20:
			ptr++;
			continue;
		//Rg
		case 0x3B:
			ptr++;
			while(true){
				if(res[ptr] == 0x00 || res[ptr] == 0x0A) break;
				ptr++;
			}
			line++;
			break;
		} // switch

		ope = '\0';
		for(i = MML.length - 1; i >= 0; i--){
			//v镶
			if(MML[i] == x){
				ope = (char)x;
				break;
			}
		}

		//|C^i߂
		ptr++;

		//v镶
		if(ope == '\0') continue;

		//
		switch(ope){
//I
		case '!':
			ptr = 0x10000;
			break;
//gbNԍ
		case '#':
			if((n = getInt(true)) >= 0 && n < 8){
				tr = n;
				q[8] = q[tr];
				update_q[8] = update_q[tr];
				last_long = -1;
			}else
				err(line, "`lԍ̎w肪sł");
			break;
//ftHg̉
		case 'l':
			if((n = getInt(true)) >= 0)
				def_long = n;
			else
				err(line, "ftHg̉̎w肪sł");
			break;
//剹
		case 'w':
			if((n = getInt(true)) >= 0){
				input(0xE0);	//E0 剹
				input(n);
			}else
				err(line, "ʂ̎w肪sł");
			break;
//`l
		case 'v':
			if((n = getInt(true)) >= 0){
				input(0xE7);	//E7 `l
				input(n);
			}else
				err(line, "ʂ̎w肪sł");
			break;
//s
		case 'q':
			if((n = getHex()) >= 0 && n < 0x80){
//				if (n != q[tr]) {
					q[tr] = q[8] = n;
					update_q[tr] = update_q[8] = true;
//				}
			}else
				err(line, "q");
			break;

//ʒu
		case 'y':
			if((n = getInt(true)) >= 0 && n <= 20){
				input(0xDB);	//DB ʒu
				input(n);
			}else
				err(line, "Xs[J[ʒu̎w肪sł");
			break;
//Cg̏I
		case '/':
			ptrI[tr] = ptrE[tr];
			intro = true;
			last_long = -1;
//			update_q[tr] = update_q[8] = true;
			break;
//x
		case 't':
			if((n = getInt(true)) >= 0){
				input(0xE2);	//E2 e|ύX
				input(n);
			}else
				err(line, "e|̎w肪sł");
			break;
//K
		case 'o':
			//͈
			if((n = getInt(true)) > 0 && n <= 6)
				octave = n;
			else
				err(line, "IN^[u̎w肪sł");
			break;
//F
		case '@':
			if((n = getInt(true)) >= 0 && n <= 18){
				input(0xDA);	//DA FύX
				input(n);
				melody[tr] = n;
			//h
			}else if(n >= 21 && n <= 29){
				melody[tr] = n;
			}else
				err(line, "F̎w肪sł");
			break;
//[vn܂
		case '[':
			//[v̐
			if((m = ptrL[LOOP_MAX]) == LOOP_MAX){
				err(line, "[v̐ől𒴂܂");
				break;
			}
			start_loop = ptrL[m] = ptrE[8];	//[vs
			last_tr = tr;
			tr = 8;	//[vpgbN
			last_long = -1;
			melody[8] = melody[last_tr];
//			update_q[tr] =
//			update_q[8] = true;
			break;
//[vI
		case ']':
			// [v
			if((n = getInt(true)) < 1 || n > 127){
				err(line, "[v񐔂̒lsł");
				n = 1;
			}

			input(0x00);
			
			tr = last_tr;	//gbNԍ߂
			m = ptrL[LOOP_MAX];	//[v̐
			//݂̃|C^  [v̂gbN
			ptrL[m] = ptrE[tr] + 1 + (tr << 16);
			ptrL[LOOP_MAX]++;	//[v̐

			input(0xE9);
			input(start_loop);		//[vs  [vI[
			input(start_loop >> 8);
			input(n);
			break;
//[vg
		case '*':
			last_long = -1;
			// [v
			if((n = getInt(false)) == 0 || n > 127){
				err(line, "u*v[v񐔂̒lsł");
				n = 1;
			}
			if(n == -1) n = 1;

			m = ptrL[LOOP_MAX];

			//݂̃|C^  [v̂gbN
			ptrL[m] = ptrE[tr] + 1 + (tr << 16);
			ptrL[LOOP_MAX]++;	//[v̐
			input(0xE9);
			input(start_loop);		//[vs  [vI[
			input(start_loop >> 8);
			input(n);
			break;
//ru[g
		case 'p':
			if((n = getInt(true)) > 0 && res[ptr++] == 0x2C &&
			(m = getInt(true)) > 0){
				input(0xDE);	// DE ru[g
				input(0x00);
				input(n);
				input(m);
			}else if(n == 0){
				input(0xDF);
			}else err(line, "upvru[g̐ݒɌ肪܂");
			break;
//OAn܂
		case '{':
			if(!renpu) renpu = true;
			else err(line, "u{v");
			break;
//OAI
		case '}':
			if(renpu) renpu = false;
			else err(line, "u}v");
			break;
//IN^[uύX 
		case '>':
			if(++octave > 7){
				octave = 7;
				err(line, "u>v");
			}
			break;
//IN^[uύX 
		case '<':
			if(--octave < 0){
				octave = 0;
				err(line, "u<v");
			}
			break;
//X[
		case '&':
			if(slur) err(line, "&");
			slur = true;
			break;
//ړ
		case '$':
			if((n = getHex()) >= 0)	input(n);
			else err(line, "$ ̒lsł");
			break;
//ExE^C
		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'a':
		case 'b':
		case 'r':
		case '^':
			//x
			n =
				(ope == 'r') ? 0xC7 :	//x
				(ope == '^') ? 0xC6 :	//^C
				getTone( (int)ope );
			m = melody[tr];
			//G[
			if(n < 0) n = 0xC7;
			//h
			else if(m >= 21 && m <= 30 && n < 0xC6){
				n = 0xD0 + m - 21;
				melody[tr] = -1;
			}
			//X[Ƃ
			if(slur){
				slur = false;
				input(0xDD);
				input(0);
				input(last_long);
				input(n & 0x7F);
			}
			//
			if((m = getLength()) >= 0x80){
				//Ƃ
				input(0x60);
				//qƂ
				if(update_q[tr]){
					input(q[tr]);
					update_q[tr] = update_q[8] = false;
				}
				input(n);
				m -= 0x60;
				while(m > 0x60){
					m -= 0x60;
					input(0xC6);
				}
				if(m > 0){
					if(m != 0x60) input(m);
					input(0xC6);
				}
				last_long = m;
				break;
			//KvƂ
			}else if(m > 0){
				input(m);
				last_long = m;
				//qƂ
				if(update_q[tr]){
					input(q[tr]);
					update_q[tr] =
					update_q[8] = false;
				}
			}

			input(n);
			break;
		default:
			err(line, "`̋Lł");
		} //switch


		//eʃI[o[
		if(ptrE[tr] >= TR_MAX){
			err(line, "gbN " + tr + " ̃TCY傫܂");
			ptr = 0x10000;
			break;
		}
	}
	//I
	for(i = TRACK - 1; i >= 0; i--){
		//f[^Ȃꍇ
		if(ptrE[i] <= 0) continue;
		tr = i;
		input(0x00);
		ptrE[i]--;
	}
}
//	#	#	#	#	#	#	#	#	#	#
//	JnAhXϊ
//	#	#	#	#	#	#	#	#	#	#
private static void make_add(){
	int x = startARAM + epiepi_size;
	for(int i = 0; i < TRACK; i++){
		ptrA[i] = (ptrE[i] != 0) ? x : 0;
		//Cg
		if(intro && i <= 7 && ptrI[i] > 0)
			ptrI[i] += ptrA[i];
		x += ptrE[i] + 1;
	}
}
//	#	#	#	#	#	#	#	#	#	#
//	[vAhXϊ
//	#	#	#	#	#	#	#	#	#	#
private static void make_loop(){
	int m, n;
	//[v̐
	int x = ptrL[LOOP_MAX] - 1;
	if(x < 0)
		return;

	for(int i = x; i >= 0; i--){
		//[v̂gbNƂ̃|C^
		m = ptrL[i];
		if(m == 0) continue;
		tr = m >>> 16;
		//[vAhX
		m &= 65535;
		//[v̍s
		n = ptrA[8] + (epi[tr][m] & 255) + (epi[tr][m + 1] << 8);
		//AhXϊ
		epi[tr][m]     = byte2(n);
		epi[tr][m + 1] = byte2(n >>> 8);
	}
}

} // Canvas
